'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _elemental = require('elemental');

var _babblerJs = require('babbler-js');

var _babblerJs2 = _interopRequireDefault(_babblerJs);

var _babblerScriptJs = require('babbler-script-js');

var _babblerScriptJs2 = _interopRequireDefault(_babblerScriptJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// BabblerScriptControlBar.js

var React = require('react');

//import BabblerScript from '../../babbler-script-js/src/babbler-script';

var btnStyle = {
    margin: 12,
    paddingLeft: "0.6em",
    paddingRight: "0.6em"
};

var iconStyle = {
    fill: "white",
    stroke: "none"

    // Управление ходом выполнения скрипта BabblerScript
};var BabblerScriptControlBar = React.createClass({
    displayName: 'BabblerScriptControlBar',


    getInitialState: function getInitialState() {
        return {
            deviceStatus: this.props.babblerScript.babbler.deviceStatus,
            scriptState: this.props.babblerScript.state,
            err: ''
        };
    },

    componentDidMount: function componentDidMount() {
        // слушаем статус устройства
        this.deviceStatusListener = function (status) {
            this.setState({ deviceStatus: status });
        }.bind(this);
        this.programStateListener = function (state, err) {
            this.setState({ scriptState: state });
        }.bind(this);

        this.props.babblerScript.babbler.on(_babblerJs2.default.Event.STATUS, this.deviceStatusListener);
        this.props.babblerScript.on(_babblerScriptJs2.default.Event.STATE, this.programStateListener);
    },

    componentWillUnmount: function componentWillUnmount() {
        // почистим слушателей
        this.props.babblerScript.babbler.removeListener(_babblerJs2.default.Event.STATUS, this.deviceStatusListener);
        this.props.babblerScript.removeListener(_babblerScriptJs2.default.Event.STATE, this.programStateListener);
    },

    render: function render() {
        var connected = this.state.deviceStatus === _babblerJs2.default.Status.CONNECTED ? true : false;

        return React.createElement(
            'span',
            { style: _extends({}, this.props.style, { textAlign: "center" }) },
            React.createElement(
                _elemental.Button,
                { size: 'lg', type: 'danger',
                    onClick: this.script_stop,
                    disabled: !connected,
                    style: btnStyle },
                React.createElement(
                    'svg',
                    { version: '1.0',
                        width: '20', height: '20',
                        viewBox: '0 0 265 265' },
                    React.createElement('path', { d: 'M196.875 287.1562 L34.875 287.1562 L34.875 125.1562 L196.875 125.1562 L196.875 287.1562 Z',
                        style: iconStyle })
                )
            ),
            this.state.scriptState === _babblerScriptJs2.default.State.STOPPED ? React.createElement(
                _elemental.Button,
                { size: 'lg', type: 'primary',
                    onClick: this.script_start,
                    disabled: !connected,
                    style: btnStyle },
                React.createElement(
                    'svg',
                    { version: '1.0',
                        width: '20', height: '20',
                        viewBox: '0 40 250 250' },
                    React.createElement('path', { d: 'M160.875 202.5 L70.875 292.5 L70.875 112.5 L160.875 202.5 Z',
                        style: iconStyle })
                )
            ) : "",
            this.state.scriptState === _babblerScriptJs2.default.State.RUNNING ? React.createElement(
                _elemental.Button,
                { size: 'lg', type: 'primary',
                    onClick: this.script_pause,
                    disabled: !connected,
                    style: btnStyle },
                React.createElement(
                    'svg',
                    { version: '1.0',
                        width: '20', height: '20',
                        viewBox: '0 0 265 265' },
                    React.createElement('path', { d: 'M169.875 301.5 L133.875 301.5 L133.875 121.5 L169.875 121.5 L169.875 301.5 ZM97.875 301.5 L61.875 301.5 L61.875 121.5 L97.875 121.5 L97.875 301.5 Z',
                        style: iconStyle })
                )
            ) : "",
            this.state.scriptState === _babblerScriptJs2.default.State.PAUSED || this.state.scriptState === _babblerScriptJs2.default.State.ERROR ? React.createElement(
                _elemental.Button,
                { size: 'lg', type: 'primary',
                    onClick: this.script_resume,
                    disabled: !connected,
                    style: btnStyle },
                React.createElement(
                    'svg',
                    { version: '1.0',
                        width: '20', height: '20',
                        viewBox: '0 40 250 250' },
                    React.createElement('path', { d: 'M160.875 202.5 L70.875 292.5 L70.875 112.5 L160.875 202.5 Z',
                        style: iconStyle })
                )
            ) : ""
        );
    },

    script_start: function script_start() {
        this.props.babblerScript.runProgram();
    },
    script_stop: function script_stop() {
        this.props.babblerScript.stop();
    },
    script_pause: function script_pause() {
        this.props.babblerScript.pause();
    },
    script_resume: function script_resume() {
        this.props.babblerScript.resume();
    }
});

// отправляем компонент на публику
module.exports = BabblerScriptControlBar;